/******************************************
MODULO: fifo.c
SCOPO: esempio di IPC mediante named pipe

USO: Lanciare due copie del programma su due
shell separate, una con flag -0 e 
l'altra con flag -1.
Lanciare prima quella con flag -1 che crea 
la fifo.
La copia del programma con flag -0 leggera'
quanto scritto dalla copia con flag -1.
******************************************/
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

int main (int argc, char *argv[]) {
  int i,fd;
  char buf[64];

  if (argc != 2) {
    printf("Usage: fifo.x -[0|1]\n\t -0 to read\n\t -1 to write\n");
    exit(1);
  } else if (strncmp(argv[1], "-1", 2)==0){
    if (mknod("fifo",S_IFIFO|0777,0)== -1) {
      perror("mknod");
      exit(1);
    } 
    if ((fd = open("fifo",O_WRONLY))==-1){
      perror("FIFO: -1");
      unlink("fifo");
      exit(1);
    } 
  } else if (strncmp(argv[1], "-0", 2)==0){
    if ((fd = open("fifo",O_RDONLY))==-1){
      perror("FIFO: -1");
      unlink("fifo");
      exit(1);
    }
  } else {
    printf("Wrong parameter: %s\n", argv[1]);
    unlink("fifo");
    exit(1);
  }
  for (i=0;i<20;i++) {
    if (strncmp(argv[1], "-1", 2)==0){
      write(fd,"HELLO",6);
      printf("Written HELLO %d \n", i);
    } else {
      read(fd,buf,6);
      printf("Read %s %d\n",buf,i);}}}
