/******************************************
MODULO: signal.c
SCOPO: esempio di ricezione di segnali
******************************************/
#include <stdio.h>
#include <limits.h>
#include <math.h>
#include <signal.h>
#include <stdlib.h>

long maxprim = 0;
long np=0;

void usr12_handler (int s) {
  printf ("\nRicevuto segnale n.%d\n",s);
  printf ("Il piu` grande primo trovato e` %ld\n",maxprim);
  printf ("Totale dei  numeri primi=%d\n",np);
}

void good_bye (int s) {
  printf ("\nIl piu` grande primo trovato e` %ld\n",maxprim);
  printf ("Totale dei  numeri primi=%d\n",np);  
  printf ("Ciao!\n");
  exit (1);
}

int is_prime (long x) {
  long fatt; 
  long maxfatt = (long)ceil(sqrt((double)x));
  if (x < 4) return 1;
  if (x % 2 == 0) return 0;

  for (fatt=3; fatt<=maxfatt; fatt+=2)
    return (x % fatt == 0 ? 0: 1);
}

int main (int argc, char *argv[]) {
  long n;

  signal (SIGUSR1, usr12_handler);
  /* signal (SIGUSR2, usr12_handler); */
  signal (SIGHUP, good_bye);

  printf("Usa kill -SIGUSR1 %d per vedere il numero: primo corrente\n", getpid());
  printf("Usa kill -SIGHUP %d per uscire", getpid()); 
  fflush(stdout);

  for (n=0; n<LONG_MAX; n++)
  if (is_prime(n)) {
    maxprim = n;
    np++;
  }
}
