/******************************************
MODULO: wait.c
SCOPO: esempio d'uso di wait()
******************************************/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <sys/types.h>
#include "mylib.h"

int main (int argc, char *argv[]){
  pid_t child;
  int status;
  
  if ((child=fork()) == 0) {
    sleep(5);
    puts ("figlio 1 - termino con stato 3");
    exit (3);
  }

  if (child == -1)
    syserr (argv[0], "fork() fallita");

  if ((child=fork()) == 0) {
    puts ("figlio 2 - sono in loop infinito, uccidimi con:");
    printf ("  kill -9 %d\n", getpid());
  
    while (1) ;
  }

  if (child == -1)
    syserr (argv[0], "fork() fallita");

  while ((child=wait(&status)) != -1) {
  /*while ((child=waitpid(-1, &status, WUNTRACED|WCONTINUED)) != -1) {*/
    printf ("il figlio con PID %d e'", child);
    if (WIFEXITED(status)) {
      printf ("terminato (stato di uscita: %d)\n\n",
        WEXITSTATUS(status));
    } else if (WIFSIGNALED(status)) {
      printf ("stato ucciso (segnale omicida: %d)\n\n",
        WTERMSIG(status));
    } else if (WIFSTOPPED(status)) {
      puts ("stato bloccato");
      printf ("(segnale bloccante: %d)\n\n",
        WSTOPSIG(status));
    } else if (WIFCONTINUED(status)) {
      puts ("stato sbloccato");
    } else
      puts ("non c'e` piu` !?");
  }
  return 0;
}
